/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <rfc2459_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_BasicConstraints(unsigned char *p, size_t len, const BasicConstraints *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* pathLenConstraint */
if((data)->pathLenConstraint) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_unsigned(p, len, (data)->pathLenConstraint, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* cA */
if((data)->cA) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_boolean(p, len, (data)->cA, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Boolean, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_BasicConstraints(const unsigned char *p, size_t len, BasicConstraints *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t cA_datalen, cA_oldlen;
Der_type cA_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &cA_type, UT_Boolean, &cA_datalen, &l);
if (e == 0 && cA_type != PRIM) { e = ASN1_BAD_ID; }
if(e) {
(data)->cA = NULL;
} else {
(data)->cA = calloc(1, sizeof(*(data)->cA));
if ((data)->cA == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
cA_oldlen = len;
if (cA_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = cA_datalen;
e = der_get_boolean(p, len, (data)->cA, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = cA_oldlen - cA_datalen;
}
}
{
size_t pathLenConstraint_datalen, pathLenConstraint_oldlen;
Der_type pathLenConstraint_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &pathLenConstraint_type, UT_Integer, &pathLenConstraint_datalen, &l);
if (e == 0 && pathLenConstraint_type != PRIM) { e = ASN1_BAD_ID; }
if(e) {
(data)->pathLenConstraint = NULL;
} else {
(data)->pathLenConstraint = calloc(1, sizeof(*(data)->pathLenConstraint));
if ((data)->pathLenConstraint == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
pathLenConstraint_oldlen = len;
if (pathLenConstraint_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = pathLenConstraint_datalen;
e = der_get_unsigned(p, len, (data)->pathLenConstraint, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = pathLenConstraint_oldlen - pathLenConstraint_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_BasicConstraints(data);
return e;
}

void ASN1CALL
free_BasicConstraints(BasicConstraints *data)
{
if((data)->cA) {
free((data)->cA);
(data)->cA = NULL;
}
if((data)->pathLenConstraint) {
free((data)->pathLenConstraint);
(data)->pathLenConstraint = NULL;
}
}

size_t ASN1CALL
length_BasicConstraints(const BasicConstraints *data)
{
size_t ret = 0;
if((data)->cA){
size_t Top_tag_oldret = ret;
ret = 0;
ret += 1;
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->pathLenConstraint){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_unsigned((data)->pathLenConstraint);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_BasicConstraints(const BasicConstraints *from, BasicConstraints *to)
{
memset(to, 0, sizeof(*to));
if((from)->cA) {
(to)->cA = malloc(sizeof(*(to)->cA));
if((to)->cA == NULL) goto fail;
*((to)->cA) = *((from)->cA);
}else
(to)->cA = NULL;
if((from)->pathLenConstraint) {
(to)->pathLenConstraint = malloc(sizeof(*(to)->pathLenConstraint));
if((to)->pathLenConstraint == NULL) goto fail;
*((to)->pathLenConstraint) = *((from)->pathLenConstraint);
}else
(to)->pathLenConstraint = NULL;
return 0;
fail:
free_BasicConstraints(to);
return ENOMEM;
}



