/* Generated from ./cms.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <cms_asn1.h>
#include <cms_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_CMSEncryptedData(unsigned char *p, size_t len, const CMSEncryptedData *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* unprotectedAttrs */
if((data)->unprotectedAttrs) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_heim_any(p, len, (data)->unprotectedAttrs, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* encryptedContentInfo */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_EncryptedContentInfo(p, len, &(data)->encryptedContentInfo, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* version */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_CMSVersion(p, len, &(data)->version, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_CMSEncryptedData(const unsigned char *p, size_t len, CMSEncryptedData *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if((is_indefinite = _heim_fix_dce(Top_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }e = decode_CMSVersion(p, len, &(data)->version, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_EncryptedContentInfo(p, len, &(data)->encryptedContentInfo, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t unprotectedAttrs_datalen, unprotectedAttrs_oldlen;
Der_type unprotectedAttrs_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &unprotectedAttrs_type, 1, &unprotectedAttrs_datalen, &l);
if (e == 0 && unprotectedAttrs_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->unprotectedAttrs = NULL;
} else {
(data)->unprotectedAttrs = calloc(1, sizeof(*(data)->unprotectedAttrs));
if ((data)->unprotectedAttrs == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
unprotectedAttrs_oldlen = len;
if((is_indefinite = _heim_fix_dce(unprotectedAttrs_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }e = decode_heim_any(p, len, (data)->unprotectedAttrs, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &unprotectedAttrs_type, UT_EndOfContent, &unprotectedAttrs_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (unprotectedAttrs_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = unprotectedAttrs_oldlen - unprotectedAttrs_datalen;
}
}
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &Top_type, UT_EndOfContent, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (Top_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_CMSEncryptedData(data);
return e;
}

void ASN1CALL
free_CMSEncryptedData(CMSEncryptedData *data)
{
free_CMSVersion(&(data)->version);
free_EncryptedContentInfo(&(data)->encryptedContentInfo);
if((data)->unprotectedAttrs) {
free_heim_any((data)->unprotectedAttrs);
free((data)->unprotectedAttrs);
(data)->unprotectedAttrs = NULL;
}
}

size_t ASN1CALL
length_CMSEncryptedData(const CMSEncryptedData *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_CMSVersion(&(data)->version);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_EncryptedContentInfo(&(data)->encryptedContentInfo);
ret += Top_tag_oldret;
}
if((data)->unprotectedAttrs){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_heim_any((data)->unprotectedAttrs);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_CMSEncryptedData(const CMSEncryptedData *from, CMSEncryptedData *to)
{
memset(to, 0, sizeof(*to));
if(copy_CMSVersion(&(from)->version, &(to)->version)) goto fail;
if(copy_EncryptedContentInfo(&(from)->encryptedContentInfo, &(to)->encryptedContentInfo)) goto fail;
if((from)->unprotectedAttrs) {
(to)->unprotectedAttrs = malloc(sizeof(*(to)->unprotectedAttrs));
if((to)->unprotectedAttrs == NULL) goto fail;
if(copy_heim_any((from)->unprotectedAttrs, (to)->unprotectedAttrs)) goto fail;
}else
(to)->unprotectedAttrs = NULL;
return 0;
fail:
free_CMSEncryptedData(to);
return ENOMEM;
}



