/* Generated from ./cms.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <cms_asn1.h>
#include <cms_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_CMSIdentifier(unsigned char *p, size_t len, const CMSIdentifier *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;

switch((data)->element) {
case choice_CMSIdentifier_subjectKeyIdentifier: {size_t Top_oldret = ret;
ret = 0;
e = encode_SubjectKeyIdentifier(p, len, &((data))->u.subjectKeyIdentifier, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
case choice_CMSIdentifier_issuerAndSerialNumber: {size_t Top_oldret = ret;
ret = 0;
e = encode_IssuerAndSerialNumber(p, len, &((data))->u.issuerAndSerialNumber, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
};
*size = ret;
return 0;
}

int ASN1CALL
decode_CMSIdentifier(const unsigned char *p, size_t len, CMSIdentifier *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
if (der_match_tag(p, len, ASN1_C_UNIV, CONS, UT_Sequence, NULL) == 0) {
e = decode_IssuerAndSerialNumber(p, len, &(data)->u.issuerAndSerialNumber, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
(data)->element = choice_CMSIdentifier_issuerAndSerialNumber;
}
else if (der_match_tag(p, len, ASN1_C_CONTEXT, CONS, 0, NULL) == 0) {
{
size_t subjectKeyIdentifier_datalen, subjectKeyIdentifier_oldlen;
Der_type subjectKeyIdentifier_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &subjectKeyIdentifier_type, 0, &subjectKeyIdentifier_datalen, &l);
if (e == 0 && subjectKeyIdentifier_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
subjectKeyIdentifier_oldlen = len;
if((is_indefinite = _heim_fix_dce(subjectKeyIdentifier_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }e = decode_SubjectKeyIdentifier(p, len, &(data)->u.subjectKeyIdentifier, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &subjectKeyIdentifier_type, UT_EndOfContent, &subjectKeyIdentifier_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (subjectKeyIdentifier_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = subjectKeyIdentifier_oldlen - subjectKeyIdentifier_datalen;
}
(data)->element = choice_CMSIdentifier_subjectKeyIdentifier;
}
else {
e = ASN1_PARSE_ERROR;
goto fail;
}
if(size) *size = ret;
return 0;
fail:
free_CMSIdentifier(data);
return e;
}

void ASN1CALL
free_CMSIdentifier(CMSIdentifier *data)
{
switch((data)->element) {
case choice_CMSIdentifier_issuerAndSerialNumber:
free_IssuerAndSerialNumber(&(data)->u.issuerAndSerialNumber);
break;
case choice_CMSIdentifier_subjectKeyIdentifier:
free_SubjectKeyIdentifier(&(data)->u.subjectKeyIdentifier);
break;
}
}

size_t ASN1CALL
length_CMSIdentifier(const CMSIdentifier *data)
{
size_t ret = 0;
switch((data)->element) {
case choice_CMSIdentifier_issuerAndSerialNumber:
{
size_t Top_oldret = ret;
ret = 0;
ret += length_IssuerAndSerialNumber(&(data)->u.issuerAndSerialNumber);
ret += Top_oldret;
}
break;
case choice_CMSIdentifier_subjectKeyIdentifier:
{
size_t Top_oldret = ret;
ret = 0;
ret += length_SubjectKeyIdentifier(&(data)->u.subjectKeyIdentifier);
ret += 1 + der_length_len (ret);
ret += Top_oldret;
}
break;
}
return ret;
}

int ASN1CALL
copy_CMSIdentifier(const CMSIdentifier *from, CMSIdentifier *to)
{
memset(to, 0, sizeof(*to));
(to)->element = (from)->element;
switch((from)->element) {
case choice_CMSIdentifier_issuerAndSerialNumber:
if(copy_IssuerAndSerialNumber(&(from)->u.issuerAndSerialNumber, &(to)->u.issuerAndSerialNumber)) goto fail;
break;
case choice_CMSIdentifier_subjectKeyIdentifier:
if(copy_SubjectKeyIdentifier(&(from)->u.subjectKeyIdentifier, &(to)->u.subjectKeyIdentifier)) goto fail;
break;
}
return 0;
fail:
free_CMSIdentifier(to);
return ENOMEM;
}



