/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <rfc2459_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_DHParameter(unsigned char *p, size_t len, const DHParameter *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* privateValueLength */
if((data)->privateValueLength) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, (data)->privateValueLength, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* base */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, &(data)->base, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* prime */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, &(data)->prime, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_DHParameter(const unsigned char *p, size_t len, DHParameter *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t prime_datalen, prime_oldlen;
Der_type prime_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &prime_type, UT_Integer, &prime_datalen, &l);
if (e == 0 && prime_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
prime_oldlen = len;
if (prime_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = prime_datalen;
e = der_get_heim_integer(p, len, &(data)->prime, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = prime_oldlen - prime_datalen;
}
{
size_t base_datalen, base_oldlen;
Der_type base_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &base_type, UT_Integer, &base_datalen, &l);
if (e == 0 && base_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
base_oldlen = len;
if (base_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = base_datalen;
e = der_get_heim_integer(p, len, &(data)->base, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = base_oldlen - base_datalen;
}
{
size_t privateValueLength_datalen, privateValueLength_oldlen;
Der_type privateValueLength_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &privateValueLength_type, UT_Integer, &privateValueLength_datalen, &l);
if (e == 0 && privateValueLength_type != PRIM) { e = ASN1_BAD_ID; }
if(e) {
(data)->privateValueLength = NULL;
} else {
(data)->privateValueLength = calloc(1, sizeof(*(data)->privateValueLength));
if ((data)->privateValueLength == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
privateValueLength_oldlen = len;
if (privateValueLength_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = privateValueLength_datalen;
e = der_get_heim_integer(p, len, (data)->privateValueLength, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = privateValueLength_oldlen - privateValueLength_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_DHParameter(data);
return e;
}

void ASN1CALL
free_DHParameter(DHParameter *data)
{
der_free_heim_integer(&(data)->prime);
der_free_heim_integer(&(data)->base);
if((data)->privateValueLength) {
der_free_heim_integer((data)->privateValueLength);
free((data)->privateValueLength);
(data)->privateValueLength = NULL;
}
}

size_t ASN1CALL
length_DHParameter(const DHParameter *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer(&(data)->prime);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer(&(data)->base);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->privateValueLength){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer((data)->privateValueLength);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_DHParameter(const DHParameter *from, DHParameter *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_heim_integer(&(from)->prime, &(to)->prime)) goto fail;
if(der_copy_heim_integer(&(from)->base, &(to)->base)) goto fail;
if((from)->privateValueLength) {
(to)->privateValueLength = malloc(sizeof(*(to)->privateValueLength));
if((to)->privateValueLength == NULL) goto fail;
if(der_copy_heim_integer((from)->privateValueLength, (to)->privateValueLength)) goto fail;
}else
(to)->privateValueLength = NULL;
return 0;
fail:
free_DHParameter(to);
return ENOMEM;
}



