/* Generated from ./pkinit.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <pkinit_asn1.h>
#include <pkinit_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_DHRepInfo(unsigned char *p, size_t len, const DHRepInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* kdf */
if((data)->kdf) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_KDFAlgorithmId(p, len, (data)->kdf, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 2, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* serverDHNonce */
if((data)->serverDHNonce) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_DHNonce(p, len, (data)->serverDHNonce, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* dhSignedData */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, &(data)->dhSignedData, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, PRIM, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_DHRepInfo(const unsigned char *p, size_t len, DHRepInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t dhSignedData_datalen, dhSignedData_oldlen;
Der_type dhSignedData_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &dhSignedData_type, 0, &dhSignedData_datalen, &l);
if (e == 0 && dhSignedData_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
dhSignedData_oldlen = len;
if (dhSignedData_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = dhSignedData_datalen;
e = der_get_octet_string(p, len, &(data)->dhSignedData, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = dhSignedData_oldlen - dhSignedData_datalen;
}
{
size_t serverDHNonce_datalen, serverDHNonce_oldlen;
Der_type serverDHNonce_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &serverDHNonce_type, 1, &serverDHNonce_datalen, &l);
if (e == 0 && serverDHNonce_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->serverDHNonce = NULL;
} else {
(data)->serverDHNonce = calloc(1, sizeof(*(data)->serverDHNonce));
if ((data)->serverDHNonce == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
serverDHNonce_oldlen = len;
if (serverDHNonce_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = serverDHNonce_datalen;
e = decode_DHNonce(p, len, (data)->serverDHNonce, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = serverDHNonce_oldlen - serverDHNonce_datalen;
}
}
{
size_t kdf_datalen, kdf_oldlen;
Der_type kdf_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &kdf_type, 2, &kdf_datalen, &l);
if (e == 0 && kdf_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->kdf = NULL;
} else {
(data)->kdf = calloc(1, sizeof(*(data)->kdf));
if ((data)->kdf == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
kdf_oldlen = len;
if (kdf_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = kdf_datalen;
e = decode_KDFAlgorithmId(p, len, (data)->kdf, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = kdf_oldlen - kdf_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_DHRepInfo(data);
return e;
}

void ASN1CALL
free_DHRepInfo(DHRepInfo *data)
{
der_free_octet_string(&(data)->dhSignedData);
if((data)->serverDHNonce) {
free_DHNonce((data)->serverDHNonce);
free((data)->serverDHNonce);
(data)->serverDHNonce = NULL;
}
if((data)->kdf) {
free_KDFAlgorithmId((data)->kdf);
free((data)->kdf);
(data)->kdf = NULL;
}
}

size_t ASN1CALL
length_DHRepInfo(const DHRepInfo *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_octet_string(&(data)->dhSignedData);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->serverDHNonce){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_DHNonce((data)->serverDHNonce);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->kdf){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_KDFAlgorithmId((data)->kdf);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_DHRepInfo(const DHRepInfo *from, DHRepInfo *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_octet_string(&(from)->dhSignedData, &(to)->dhSignedData)) goto fail;
if((from)->serverDHNonce) {
(to)->serverDHNonce = malloc(sizeof(*(to)->serverDHNonce));
if((to)->serverDHNonce == NULL) goto fail;
if(copy_DHNonce((from)->serverDHNonce, (to)->serverDHNonce)) goto fail;
}else
(to)->serverDHNonce = NULL;
if((from)->kdf) {
(to)->kdf = malloc(sizeof(*(to)->kdf));
if((to)->kdf == NULL) goto fail;
if(copy_KDFAlgorithmId((from)->kdf, (to)->kdf)) goto fail;
}else
(to)->kdf = NULL;
return 0;
fail:
free_DHRepInfo(to);
return ENOMEM;
}



