/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <rfc2459_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_DSASigValue(unsigned char *p, size_t len, const DSASigValue *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* s */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, &(data)->s, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* r */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, &(data)->r, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_DSASigValue(const unsigned char *p, size_t len, DSASigValue *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t r_datalen, r_oldlen;
Der_type r_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &r_type, UT_Integer, &r_datalen, &l);
if (e == 0 && r_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
r_oldlen = len;
if (r_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = r_datalen;
e = der_get_heim_integer(p, len, &(data)->r, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = r_oldlen - r_datalen;
}
{
size_t s_datalen, s_oldlen;
Der_type s_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &s_type, UT_Integer, &s_datalen, &l);
if (e == 0 && s_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
s_oldlen = len;
if (s_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = s_datalen;
e = der_get_heim_integer(p, len, &(data)->s, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = s_oldlen - s_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_DSASigValue(data);
return e;
}

void ASN1CALL
free_DSASigValue(DSASigValue *data)
{
der_free_heim_integer(&(data)->r);
der_free_heim_integer(&(data)->s);
}

size_t ASN1CALL
length_DSASigValue(const DSASigValue *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer(&(data)->r);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer(&(data)->s);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_DSASigValue(const DSASigValue *from, DSASigValue *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_heim_integer(&(from)->r, &(to)->r)) goto fail;
if(der_copy_heim_integer(&(from)->s, &(to)->s)) goto fail;
return 0;
fail:
free_DSASigValue(to);
return ENOMEM;
}



