/* Generated from ./digest.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <digest_asn1.h>
#include <digest_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_DigestREQ(unsigned char *p, size_t len, const DigestREQ *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* innerReq */
{
size_t Top_tag_tag_oldret = ret;
ret = 0;
e = encode_EncryptedData(p, len, &(data)->innerReq, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_tag_oldret;
}
/* apReq */
{
size_t Top_tag_tag_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, &(data)->apReq, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OctetString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_APPL, CONS, 128, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_DigestREQ(const unsigned char *p, size_t len, DigestREQ *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_APPL, &Top_type, 128, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t Top_Tag_datalen, Top_Tag_oldlen;
Der_type Top_Tag_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_Tag_type, UT_Sequence, &Top_Tag_datalen, &l);
if (e == 0 && Top_Tag_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_Tag_oldlen = len;
if (Top_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_Tag_datalen;
{
size_t apReq_datalen, apReq_oldlen;
Der_type apReq_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &apReq_type, 0, &apReq_datalen, &l);
if (e == 0 && apReq_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
apReq_oldlen = len;
if (apReq_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = apReq_datalen;
{
size_t apReq_Tag_datalen, apReq_Tag_oldlen;
Der_type apReq_Tag_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &apReq_Tag_type, UT_OctetString, &apReq_Tag_datalen, &l);
if (e == 0 && apReq_Tag_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
apReq_Tag_oldlen = len;
if (apReq_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = apReq_Tag_datalen;
e = der_get_octet_string(p, len, &(data)->apReq, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = apReq_Tag_oldlen - apReq_Tag_datalen;
}
len = apReq_oldlen - apReq_datalen;
}
{
size_t innerReq_datalen, innerReq_oldlen;
Der_type innerReq_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &innerReq_type, 1, &innerReq_datalen, &l);
if (e == 0 && innerReq_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
innerReq_oldlen = len;
if (innerReq_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = innerReq_datalen;
e = decode_EncryptedData(p, len, &(data)->innerReq, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = innerReq_oldlen - innerReq_datalen;
}
len = Top_Tag_oldlen - Top_Tag_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_DigestREQ(data);
return e;
}

void ASN1CALL
free_DigestREQ(DigestREQ *data)
{
der_free_octet_string(&(data)->apReq);
free_EncryptedData(&(data)->innerReq);
}

size_t ASN1CALL
length_DigestREQ(const DigestREQ *data)
{
size_t ret = 0;
{
size_t Top_tag_tag_oldret = ret;
ret = 0;
ret += der_length_octet_string(&(data)->apReq);
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_tag_oldret;
}
{
size_t Top_tag_tag_oldret = ret;
ret = 0;
ret += length_EncryptedData(&(data)->innerReq);
ret += 1 + der_length_len (ret);
ret += Top_tag_tag_oldret;
}
ret += 1 + der_length_len (ret);
ret += 3 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_DigestREQ(const DigestREQ *from, DigestREQ *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_octet_string(&(from)->apReq, &(to)->apReq)) goto fail;
if(copy_EncryptedData(&(from)->innerReq, &(to)->innerReq)) goto fail;
return 0;
fail:
free_DigestREQ(to);
return ENOMEM;
}



