/* Generated from ./digest.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <digest_asn1.h>
#include <digest_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_DigestResponse(unsigned char *p, size_t len, const DigestResponse *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* session-key */
if((data)->session_key) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, (data)->session_key, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OctetString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 3, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* channel */
if((data)->channel) {
size_t Top_tag_oldret = ret;
ret = 0;
/* cb-binding */
{
size_t channel_tag_tag_oldret = ret;
ret = 0;
e = der_put_utf8string(p, len, &((data)->channel)->cb_binding, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_UTF8String, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += channel_tag_tag_oldret;
}
/* cb-type */
{
size_t channel_tag_tag_oldret = ret;
ret = 0;
e = der_put_utf8string(p, len, &((data)->channel)->cb_type, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_UTF8String, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += channel_tag_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 2, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* tickets */
if((data)->tickets) {
size_t Top_tag_oldret = ret;
ret = 0;
for(i = ((data)->tickets)->len - 1; i >= 0; --i) {
size_t tickets_tag_tag_for_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, &((data)->tickets)->val[i], &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OctetString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += tickets_tag_tag_for_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* rsp */
if((data)->rsp) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_utf8string(p, len, (data)->rsp, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_UTF8String, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* success */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_boolean(p, len, &(data)->success, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Boolean, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_DigestResponse(const unsigned char *p, size_t len, DigestResponse *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t success_datalen, success_oldlen;
Der_type success_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &success_type, UT_Boolean, &success_datalen, &l);
if (e == 0 && success_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
success_oldlen = len;
if (success_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = success_datalen;
e = der_get_boolean(p, len, &(data)->success, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = success_oldlen - success_datalen;
}
{
size_t rsp_datalen, rsp_oldlen;
Der_type rsp_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &rsp_type, 0, &rsp_datalen, &l);
if (e == 0 && rsp_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->rsp = NULL;
} else {
(data)->rsp = calloc(1, sizeof(*(data)->rsp));
if ((data)->rsp == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
rsp_oldlen = len;
if (rsp_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = rsp_datalen;
{
size_t rsp_Tag_datalen, rsp_Tag_oldlen;
Der_type rsp_Tag_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &rsp_Tag_type, UT_UTF8String, &rsp_Tag_datalen, &l);
if (e == 0 && rsp_Tag_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
rsp_Tag_oldlen = len;
if (rsp_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = rsp_Tag_datalen;
e = der_get_utf8string(p, len, (data)->rsp, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = rsp_Tag_oldlen - rsp_Tag_datalen;
}
len = rsp_oldlen - rsp_datalen;
}
}
{
size_t tickets_datalen, tickets_oldlen;
Der_type tickets_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &tickets_type, 1, &tickets_datalen, &l);
if (e == 0 && tickets_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->tickets = NULL;
} else {
(data)->tickets = calloc(1, sizeof(*(data)->tickets));
if ((data)->tickets == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
tickets_oldlen = len;
if (tickets_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = tickets_datalen;
{
size_t tickets_Tag_datalen, tickets_Tag_oldlen;
Der_type tickets_Tag_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &tickets_Tag_type, UT_Sequence, &tickets_Tag_datalen, &l);
if (e == 0 && tickets_Tag_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
tickets_Tag_oldlen = len;
if (tickets_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = tickets_Tag_datalen;
{
size_t tickets_Tag_Tag_origlen = len;
size_t tickets_Tag_Tag_oldret = ret;
size_t tickets_Tag_Tag_olen = 0;
void *tickets_Tag_Tag_tmp;
ret = 0;
((data)->tickets)->len = 0;
((data)->tickets)->val = NULL;
while(ret < tickets_Tag_Tag_origlen) {
size_t tickets_Tag_Tag_nlen = tickets_Tag_Tag_olen + sizeof(*(((data)->tickets)->val));
if (tickets_Tag_Tag_olen > tickets_Tag_Tag_nlen) { e = ASN1_OVERFLOW; goto fail; }
tickets_Tag_Tag_olen = tickets_Tag_Tag_nlen;
tickets_Tag_Tag_tmp = realloc(((data)->tickets)->val, tickets_Tag_Tag_olen);
if (tickets_Tag_Tag_tmp == NULL) { e = ENOMEM; goto fail; }
((data)->tickets)->val = tickets_Tag_Tag_tmp;
{
size_t tickets_Tag_Tag_s_of_datalen, tickets_Tag_Tag_s_of_oldlen;
Der_type tickets_Tag_Tag_s_of_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &tickets_Tag_Tag_s_of_type, UT_OctetString, &tickets_Tag_Tag_s_of_datalen, &l);
if (e == 0 && tickets_Tag_Tag_s_of_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
tickets_Tag_Tag_s_of_oldlen = len;
if (tickets_Tag_Tag_s_of_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = tickets_Tag_Tag_s_of_datalen;
e = der_get_octet_string(p, len, &((data)->tickets)->val[((data)->tickets)->len], &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = tickets_Tag_Tag_s_of_oldlen - tickets_Tag_Tag_s_of_datalen;
}
((data)->tickets)->len++;
len = tickets_Tag_Tag_origlen - ret;
}
ret += tickets_Tag_Tag_oldret;
}
len = tickets_Tag_oldlen - tickets_Tag_datalen;
}
len = tickets_oldlen - tickets_datalen;
}
}
{
size_t channel_datalen, channel_oldlen;
Der_type channel_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &channel_type, 2, &channel_datalen, &l);
if (e == 0 && channel_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->channel = NULL;
} else {
(data)->channel = calloc(1, sizeof(*(data)->channel));
if ((data)->channel == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
channel_oldlen = len;
if (channel_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = channel_datalen;
{
size_t channel_Tag_datalen, channel_Tag_oldlen;
Der_type channel_Tag_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &channel_Tag_type, UT_Sequence, &channel_Tag_datalen, &l);
if (e == 0 && channel_Tag_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
channel_Tag_oldlen = len;
if (channel_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = channel_Tag_datalen;
{
size_t cb_type_datalen, cb_type_oldlen;
Der_type cb_type_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &cb_type_type, UT_UTF8String, &cb_type_datalen, &l);
if (e == 0 && cb_type_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
cb_type_oldlen = len;
if (cb_type_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = cb_type_datalen;
e = der_get_utf8string(p, len, &((data)->channel)->cb_type, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = cb_type_oldlen - cb_type_datalen;
}
{
size_t cb_binding_datalen, cb_binding_oldlen;
Der_type cb_binding_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &cb_binding_type, UT_UTF8String, &cb_binding_datalen, &l);
if (e == 0 && cb_binding_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
cb_binding_oldlen = len;
if (cb_binding_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = cb_binding_datalen;
e = der_get_utf8string(p, len, &((data)->channel)->cb_binding, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = cb_binding_oldlen - cb_binding_datalen;
}
len = channel_Tag_oldlen - channel_Tag_datalen;
}
len = channel_oldlen - channel_datalen;
}
}
{
size_t session_key_datalen, session_key_oldlen;
Der_type session_key_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &session_key_type, 3, &session_key_datalen, &l);
if (e == 0 && session_key_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->session_key = NULL;
} else {
(data)->session_key = calloc(1, sizeof(*(data)->session_key));
if ((data)->session_key == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
session_key_oldlen = len;
if (session_key_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = session_key_datalen;
{
size_t session_key_Tag_datalen, session_key_Tag_oldlen;
Der_type session_key_Tag_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &session_key_Tag_type, UT_OctetString, &session_key_Tag_datalen, &l);
if (e == 0 && session_key_Tag_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
session_key_Tag_oldlen = len;
if (session_key_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = session_key_Tag_datalen;
e = der_get_octet_string(p, len, (data)->session_key, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = session_key_Tag_oldlen - session_key_Tag_datalen;
}
len = session_key_oldlen - session_key_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_DigestResponse(data);
return e;
}

void ASN1CALL
free_DigestResponse(DigestResponse *data)
{
if((data)->rsp) {
der_free_utf8string((data)->rsp);
free((data)->rsp);
(data)->rsp = NULL;
}
if((data)->tickets) {
while(((data)->tickets)->len){
der_free_octet_string(&((data)->tickets)->val[((data)->tickets)->len-1]);
((data)->tickets)->len--;
}
free(((data)->tickets)->val);
((data)->tickets)->val = NULL;
free((data)->tickets);
(data)->tickets = NULL;
}
if((data)->channel) {
der_free_utf8string(&((data)->channel)->cb_type);
der_free_utf8string(&((data)->channel)->cb_binding);
free((data)->channel);
(data)->channel = NULL;
}
if((data)->session_key) {
der_free_octet_string((data)->session_key);
free((data)->session_key);
(data)->session_key = NULL;
}
}

size_t ASN1CALL
length_DigestResponse(const DigestResponse *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += 1;
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->rsp){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_utf8string((data)->rsp);
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->tickets){
size_t Top_tag_oldret = ret;
ret = 0;
{
size_t tickets_tag_tag_oldret = ret;
int i;
ret = 0;
for(i = ((data)->tickets)->len - 1; i >= 0; --i){
size_t tickets_tag_tag_for_oldret = ret;
ret = 0;
ret += der_length_octet_string(&((data)->tickets)->val[i]);
ret += 1 + der_length_len (ret);
ret += tickets_tag_tag_for_oldret;
}
ret += tickets_tag_tag_oldret;
}
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->channel){
size_t Top_tag_oldret = ret;
ret = 0;
{
size_t channel_tag_tag_oldret = ret;
ret = 0;
ret += der_length_utf8string(&((data)->channel)->cb_type);
ret += 1 + der_length_len (ret);
ret += channel_tag_tag_oldret;
}
{
size_t channel_tag_tag_oldret = ret;
ret = 0;
ret += der_length_utf8string(&((data)->channel)->cb_binding);
ret += 1 + der_length_len (ret);
ret += channel_tag_tag_oldret;
}
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->session_key){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_octet_string((data)->session_key);
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_DigestResponse(const DigestResponse *from, DigestResponse *to)
{
memset(to, 0, sizeof(*to));
*(&(to)->success) = *(&(from)->success);
if((from)->rsp) {
(to)->rsp = malloc(sizeof(*(to)->rsp));
if((to)->rsp == NULL) goto fail;
if(der_copy_utf8string((from)->rsp, (to)->rsp)) goto fail;
}else
(to)->rsp = NULL;
if((from)->tickets) {
(to)->tickets = malloc(sizeof(*(to)->tickets));
if((to)->tickets == NULL) goto fail;
if((((to)->tickets)->val = malloc(((from)->tickets)->len * sizeof(*((to)->tickets)->val))) == NULL && ((from)->tickets)->len != 0)
goto fail;
for(((to)->tickets)->len = 0; ((to)->tickets)->len < ((from)->tickets)->len; ((to)->tickets)->len++){
if(der_copy_octet_string(&((from)->tickets)->val[((to)->tickets)->len], &((to)->tickets)->val[((to)->tickets)->len])) goto fail;
}
}else
(to)->tickets = NULL;
if((from)->channel) {
(to)->channel = malloc(sizeof(*(to)->channel));
if((to)->channel == NULL) goto fail;
if(der_copy_utf8string(&((from)->channel)->cb_type, &((to)->channel)->cb_type)) goto fail;
if(der_copy_utf8string(&((from)->channel)->cb_binding, &((to)->channel)->cb_binding)) goto fail;
}else
(to)->channel = NULL;
if((from)->session_key) {
(to)->session_key = malloc(sizeof(*(to)->session_key));
if((to)->session_key == NULL) goto fail;
if(der_copy_octet_string((from)->session_key, (to)->session_key)) goto fail;
}else
(to)->session_key = NULL;
return 0;
fail:
free_DigestResponse(to);
return ENOMEM;
}



