/* Generated from ./digest.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <digest_asn1.h>
#include <digest_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_DigestTypes(unsigned char *p, size_t len, const DigestTypes *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
{
unsigned char c = 0;
int rest = 0;
int bit_set = 0;
if((data)->ms_chap_v2) {
c |= 1<<2;
}
if((data)->chap_md5) {
c |= 1<<3;
}
if((data)->digest_md5) {
c |= 1<<4;
}
if((data)->ntlm_v2) {
c |= 1<<5;
}
if((data)->ntlm_v1_session) {
c |= 1<<6;
}
if((data)->ntlm_v1) {
c |= 1<<7;
}
if (c != 0 || bit_set) {
if (len < 1) return ASN1_OVERFLOW;
*p-- = c; len--; ret++;
if (!bit_set) {
rest = 0;
if(c) { 
while(c) { 
if (c & 1) break;
c = c >> 1;
rest++;
}
}
}
}
if (len < 1) return ASN1_OVERFLOW;
*p-- = rest;
len -= 1;
ret += 1;
}

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_BitString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_DigestTypes(const unsigned char *p, size_t len, DigestTypes *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_BitString, &Top_datalen, &l);
if (e == 0 && Top_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
if (len < 1) return ASN1_OVERRUN;
p++; len--; ret++;
do {
if (len < 1) break;
(data)->ntlm_v1 = (*p >> 7) & 1;
(data)->ntlm_v1_session = (*p >> 6) & 1;
(data)->ntlm_v2 = (*p >> 5) & 1;
(data)->digest_md5 = (*p >> 4) & 1;
(data)->chap_md5 = (*p >> 3) & 1;
(data)->ms_chap_v2 = (*p >> 2) & 1;
} while(0);
p += len; ret += len;
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_DigestTypes(data);
return e;
}

void ASN1CALL
free_DigestTypes(DigestTypes *data)
{
}

size_t ASN1CALL
length_DigestTypes(const DigestTypes *data)
{
size_t ret = 0;
do {
if((data)->ms_chap_v2) { ret += 1; break; }
if((data)->chap_md5) { ret += 1; break; }
if((data)->digest_md5) { ret += 1; break; }
if((data)->ntlm_v2) { ret += 1; break; }
if((data)->ntlm_v1_session) { ret += 1; break; }
if((data)->ntlm_v1) { ret += 1; break; }
} while(0);
ret += 1;
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_DigestTypes(const DigestTypes *from, DigestTypes *to)
{
memset(to, 0, sizeof(*to));
*(to) = *(from);
return 0;
}

unsigned DigestTypes2int(DigestTypes f)
{
unsigned r = 0;
if(f.ntlm_v1) r |= (1U << 0);
if(f.ntlm_v1_session) r |= (1U << 1);
if(f.ntlm_v2) r |= (1U << 2);
if(f.digest_md5) r |= (1U << 3);
if(f.chap_md5) r |= (1U << 4);
if(f.ms_chap_v2) r |= (1U << 5);
return r;
}

DigestTypes int2DigestTypes(unsigned n)
{
	DigestTypes flags;

	memset(&flags, 0, sizeof(flags));

	flags.ntlm_v1 = (n >> 0) & 1;
	flags.ntlm_v1_session = (n >> 1) & 1;
	flags.ntlm_v2 = (n >> 2) & 1;
	flags.digest_md5 = (n >> 3) & 1;
	flags.chap_md5 = (n >> 4) & 1;
	flags.ms_chap_v2 = (n >> 5) & 1;
	return flags;
}

static struct units DigestTypes_units[] = {
	{"ms-chap-v2",	1U << 5},
	{"chap-md5",	1U << 4},
	{"digest-md5",	1U << 3},
	{"ntlm-v2",	1U << 2},
	{"ntlm-v1-session",	1U << 1},
	{"ntlm-v1",	1U << 0},
	{NULL,	0}
};

const struct units * asn1_DigestTypes_units(void){
return DigestTypes_units;
}



