/* Generated from ./krb5.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <krb5_asn1.h>
#include <krb5_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_KDCOptions(unsigned char *p, size_t len, const KDCOptions *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
{
unsigned char c = 0;
if((data)->validate) {
c |= 1<<0;
}
if((data)->renew) {
c |= 1<<1;
}
if((data)->enc_tkt_in_skey) {
c |= 1<<3;
}
if((data)->renewable_ok) {
c |= 1<<4;
}
if((data)->disable_transited_check) {
c |= 1<<5;
}
if (len < 1) return ASN1_OVERFLOW;
*p-- = c; len--; ret++;
c = 0;
if((data)->constrained_delegation) {
c |= 1<<7;
}
if (len < 1) return ASN1_OVERFLOW;
*p-- = c; len--; ret++;
c = 0;
if((data)->canonicalize) {
c |= 1<<0;
}
if((data)->request_anonymous) {
c |= 1<<1;
}
if((data)->renewable) {
c |= 1<<7;
}
if (len < 1) return ASN1_OVERFLOW;
*p-- = c; len--; ret++;
c = 0;
if((data)->postdated) {
c |= 1<<1;
}
if((data)->allow_postdate) {
c |= 1<<2;
}
if((data)->proxy) {
c |= 1<<3;
}
if((data)->proxiable) {
c |= 1<<4;
}
if((data)->forwarded) {
c |= 1<<5;
}
if((data)->forwardable) {
c |= 1<<6;
}
if((data)->reserved) {
c |= 1<<7;
}
if (len < 1) return ASN1_OVERFLOW;
*p-- = c; len--; ret++;
if (len < 1) return ASN1_OVERFLOW;
*p-- = 0;
len -= 1;
ret += 1;
}

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_BitString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_KDCOptions(const unsigned char *p, size_t len, KDCOptions *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_BitString, &Top_datalen, &l);
if (e == 0 && Top_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
if (len < 1) return ASN1_OVERRUN;
p++; len--; ret++;
do {
if (len < 1) break;
(data)->reserved = (*p >> 7) & 1;
(data)->forwardable = (*p >> 6) & 1;
(data)->forwarded = (*p >> 5) & 1;
(data)->proxiable = (*p >> 4) & 1;
(data)->proxy = (*p >> 3) & 1;
(data)->allow_postdate = (*p >> 2) & 1;
(data)->postdated = (*p >> 1) & 1;
p++; len--; ret++;
if (len < 1) break;
(data)->renewable = (*p >> 7) & 1;
(data)->request_anonymous = (*p >> 1) & 1;
(data)->canonicalize = (*p >> 0) & 1;
p++; len--; ret++;
if (len < 1) break;
(data)->constrained_delegation = (*p >> 7) & 1;
p++; len--; ret++;
if (len < 1) break;
(data)->disable_transited_check = (*p >> 5) & 1;
(data)->renewable_ok = (*p >> 4) & 1;
(data)->enc_tkt_in_skey = (*p >> 3) & 1;
(data)->renew = (*p >> 1) & 1;
(data)->validate = (*p >> 0) & 1;
} while(0);
p += len; ret += len;
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_KDCOptions(data);
return e;
}

void ASN1CALL
free_KDCOptions(KDCOptions *data)
{
}

size_t ASN1CALL
length_KDCOptions(const KDCOptions *data)
{
size_t ret = 0;
ret += 5;
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_KDCOptions(const KDCOptions *from, KDCOptions *to)
{
memset(to, 0, sizeof(*to));
*(to) = *(from);
return 0;
}

unsigned KDCOptions2int(KDCOptions f)
{
unsigned r = 0;
if(f.reserved) r |= (1U << 0);
if(f.forwardable) r |= (1U << 1);
if(f.forwarded) r |= (1U << 2);
if(f.proxiable) r |= (1U << 3);
if(f.proxy) r |= (1U << 4);
if(f.allow_postdate) r |= (1U << 5);
if(f.postdated) r |= (1U << 6);
if(f.renewable) r |= (1U << 8);
if(f.request_anonymous) r |= (1U << 14);
if(f.canonicalize) r |= (1U << 15);
if(f.constrained_delegation) r |= (1U << 16);
if(f.disable_transited_check) r |= (1U << 26);
if(f.renewable_ok) r |= (1U << 27);
if(f.enc_tkt_in_skey) r |= (1U << 28);
if(f.renew) r |= (1U << 30);
if(f.validate) r |= (1U << 31);
return r;
}

KDCOptions int2KDCOptions(unsigned n)
{
	KDCOptions flags;

	memset(&flags, 0, sizeof(flags));

	flags.reserved = (n >> 0) & 1;
	flags.forwardable = (n >> 1) & 1;
	flags.forwarded = (n >> 2) & 1;
	flags.proxiable = (n >> 3) & 1;
	flags.proxy = (n >> 4) & 1;
	flags.allow_postdate = (n >> 5) & 1;
	flags.postdated = (n >> 6) & 1;
	flags.renewable = (n >> 8) & 1;
	flags.request_anonymous = (n >> 14) & 1;
	flags.canonicalize = (n >> 15) & 1;
	flags.constrained_delegation = (n >> 16) & 1;
	flags.disable_transited_check = (n >> 26) & 1;
	flags.renewable_ok = (n >> 27) & 1;
	flags.enc_tkt_in_skey = (n >> 28) & 1;
	flags.renew = (n >> 30) & 1;
	flags.validate = (n >> 31) & 1;
	return flags;
}

static struct units KDCOptions_units[] = {
	{"validate",	1U << 31},
	{"renew",	1U << 30},
	{"enc-tkt-in-skey",	1U << 28},
	{"renewable-ok",	1U << 27},
	{"disable-transited-check",	1U << 26},
	{"constrained-delegation",	1U << 16},
	{"canonicalize",	1U << 15},
	{"request-anonymous",	1U << 14},
	{"renewable",	1U << 8},
	{"postdated",	1U << 6},
	{"allow-postdate",	1U << 5},
	{"proxy",	1U << 4},
	{"proxiable",	1U << 3},
	{"forwarded",	1U << 2},
	{"forwardable",	1U << 1},
	{"reserved",	1U << 0},
	{NULL,	0}
};

const struct units * asn1_KDCOptions_units(void){
return KDCOptions_units;
}



