/* Generated from ./krb5.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <krb5_asn1.h>
#include <krb5_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_KrbFastArmor(unsigned char *p, size_t len, const KrbFastArmor *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* armor-value */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, &(data)->armor_value, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OctetString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* armor-type */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_krb5int32(p, len, &(data)->armor_type, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_KrbFastArmor(const unsigned char *p, size_t len, KrbFastArmor *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t armor_type_datalen, armor_type_oldlen;
Der_type armor_type_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &armor_type_type, 0, &armor_type_datalen, &l);
if (e == 0 && armor_type_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
armor_type_oldlen = len;
if (armor_type_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = armor_type_datalen;
e = decode_krb5int32(p, len, &(data)->armor_type, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = armor_type_oldlen - armor_type_datalen;
}
{
size_t armor_value_datalen, armor_value_oldlen;
Der_type armor_value_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &armor_value_type, 1, &armor_value_datalen, &l);
if (e == 0 && armor_value_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
armor_value_oldlen = len;
if (armor_value_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = armor_value_datalen;
{
size_t armor_value_Tag_datalen, armor_value_Tag_oldlen;
Der_type armor_value_Tag_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &armor_value_Tag_type, UT_OctetString, &armor_value_Tag_datalen, &l);
if (e == 0 && armor_value_Tag_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
armor_value_Tag_oldlen = len;
if (armor_value_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = armor_value_Tag_datalen;
e = der_get_octet_string(p, len, &(data)->armor_value, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = armor_value_Tag_oldlen - armor_value_Tag_datalen;
}
len = armor_value_oldlen - armor_value_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_KrbFastArmor(data);
return e;
}

void ASN1CALL
free_KrbFastArmor(KrbFastArmor *data)
{
free_krb5int32(&(data)->armor_type);
der_free_octet_string(&(data)->armor_value);
}

size_t ASN1CALL
length_KrbFastArmor(const KrbFastArmor *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_krb5int32(&(data)->armor_type);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_octet_string(&(data)->armor_value);
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_KrbFastArmor(const KrbFastArmor *from, KrbFastArmor *to)
{
memset(to, 0, sizeof(*to));
if(copy_krb5int32(&(from)->armor_type, &(to)->armor_type)) goto fail;
if(der_copy_octet_string(&(from)->armor_value, &(to)->armor_value)) goto fail;
return 0;
fail:
free_KrbFastArmor(to);
return ENOMEM;
}



