/* Generated from ./krb5.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <krb5_asn1.h>
#include <krb5_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_PA_FX_FAST_REQUEST(unsigned char *p, size_t len, const PA_FX_FAST_REQUEST *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;

switch((data)->element) {
case choice_PA_FX_FAST_REQUEST_armored_data: {size_t Top_oldret = ret;
ret = 0;
e = encode_KrbFastArmoredReq(p, len, &((data))->u.armored_data, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
case choice_PA_FX_FAST_REQUEST_asn1_ellipsis: {
if (len < (data)->u.asn1_ellipsis.length)
return ASN1_OVERFLOW;
p -= (data)->u.asn1_ellipsis.length;
ret += (data)->u.asn1_ellipsis.length;
memcpy(p + 1, (data)->u.asn1_ellipsis.data, (data)->u.asn1_ellipsis.length);
break;
}
};
*size = ret;
return 0;
}

int ASN1CALL
decode_PA_FX_FAST_REQUEST(const unsigned char *p, size_t len, PA_FX_FAST_REQUEST *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
if (der_match_tag(p, len, ASN1_C_CONTEXT, CONS, 0, NULL) == 0) {
{
size_t armored_data_datalen, armored_data_oldlen;
Der_type armored_data_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &armored_data_type, 0, &armored_data_datalen, &l);
if (e == 0 && armored_data_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
armored_data_oldlen = len;
if (armored_data_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = armored_data_datalen;
e = decode_KrbFastArmoredReq(p, len, &(data)->u.armored_data, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = armored_data_oldlen - armored_data_datalen;
}
(data)->element = choice_PA_FX_FAST_REQUEST_armored_data;
}
else {
(data)->u.asn1_ellipsis.data = calloc(1, len);
if ((data)->u.asn1_ellipsis.data == NULL) {
e = ENOMEM; goto fail;
}
(data)->u.asn1_ellipsis.length = len;
memcpy((data)->u.asn1_ellipsis.data, p, len);
(data)->element = choice_PA_FX_FAST_REQUEST_asn1_ellipsis;
p += len;
ret += len;
len -= len;
}
if(size) *size = ret;
return 0;
fail:
free_PA_FX_FAST_REQUEST(data);
return e;
}

void ASN1CALL
free_PA_FX_FAST_REQUEST(PA_FX_FAST_REQUEST *data)
{
switch((data)->element) {
case choice_PA_FX_FAST_REQUEST_armored_data:
free_KrbFastArmoredReq(&(data)->u.armored_data);
break;
case choice_PA_FX_FAST_REQUEST_asn1_ellipsis:
der_free_octet_string(&(data)->u.asn1_ellipsis);
break;}
}

size_t ASN1CALL
length_PA_FX_FAST_REQUEST(const PA_FX_FAST_REQUEST *data)
{
size_t ret = 0;
switch((data)->element) {
case choice_PA_FX_FAST_REQUEST_armored_data:
{
size_t Top_oldret = ret;
ret = 0;
ret += length_KrbFastArmoredReq(&(data)->u.armored_data);
ret += 1 + der_length_len (ret);
ret += Top_oldret;
}
break;
case choice_PA_FX_FAST_REQUEST_asn1_ellipsis:
ret += (data)->u.asn1_ellipsis.length;
break;
}
return ret;
}

int ASN1CALL
copy_PA_FX_FAST_REQUEST(const PA_FX_FAST_REQUEST *from, PA_FX_FAST_REQUEST *to)
{
memset(to, 0, sizeof(*to));
(to)->element = (from)->element;
switch((from)->element) {
case choice_PA_FX_FAST_REQUEST_armored_data:
if(copy_KrbFastArmoredReq(&(from)->u.armored_data, &(to)->u.armored_data)) goto fail;
break;
case choice_PA_FX_FAST_REQUEST_asn1_ellipsis: {
int ret;
ret=der_copy_octet_string(&(from)->u.asn1_ellipsis, &(to)->u.asn1_ellipsis);
if (ret) goto fail;
break;
}
}
return 0;
fail:
free_PA_FX_FAST_REQUEST(to);
return ENOMEM;
}



