/* Generated from ./krb5.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <krb5_asn1.h>
#include <krb5_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_PA_SvrReferralData(unsigned char *p, size_t len, const PA_SvrReferralData *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* referred-realm */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Realm(p, len, &(data)->referred_realm, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* referred-name */
if((data)->referred_name) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_PrincipalName(p, len, (data)->referred_name, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_PA_SvrReferralData(const unsigned char *p, size_t len, PA_SvrReferralData *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t referred_name_datalen, referred_name_oldlen;
Der_type referred_name_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &referred_name_type, 1, &referred_name_datalen, &l);
if (e == 0 && referred_name_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->referred_name = NULL;
} else {
(data)->referred_name = calloc(1, sizeof(*(data)->referred_name));
if ((data)->referred_name == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
referred_name_oldlen = len;
if (referred_name_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = referred_name_datalen;
e = decode_PrincipalName(p, len, (data)->referred_name, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = referred_name_oldlen - referred_name_datalen;
}
}
{
size_t referred_realm_datalen, referred_realm_oldlen;
Der_type referred_realm_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &referred_realm_type, 0, &referred_realm_datalen, &l);
if (e == 0 && referred_realm_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
referred_realm_oldlen = len;
if (referred_realm_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = referred_realm_datalen;
e = decode_Realm(p, len, &(data)->referred_realm, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = referred_realm_oldlen - referred_realm_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_PA_SvrReferralData(data);
return e;
}

void ASN1CALL
free_PA_SvrReferralData(PA_SvrReferralData *data)
{
if((data)->referred_name) {
free_PrincipalName((data)->referred_name);
free((data)->referred_name);
(data)->referred_name = NULL;
}
free_Realm(&(data)->referred_realm);
}

size_t ASN1CALL
length_PA_SvrReferralData(const PA_SvrReferralData *data)
{
size_t ret = 0;
if((data)->referred_name){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_PrincipalName((data)->referred_name);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Realm(&(data)->referred_realm);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_PA_SvrReferralData(const PA_SvrReferralData *from, PA_SvrReferralData *to)
{
memset(to, 0, sizeof(*to));
if((from)->referred_name) {
(to)->referred_name = malloc(sizeof(*(to)->referred_name));
if((to)->referred_name == NULL) goto fail;
if(copy_PrincipalName((from)->referred_name, (to)->referred_name)) goto fail;
}else
(to)->referred_name = NULL;
if(copy_Realm(&(from)->referred_realm, &(to)->referred_realm)) goto fail;
return 0;
fail:
free_PA_SvrReferralData(to);
return ENOMEM;
}



