/* Generated from ./pkcs12.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <pkcs12_asn1.h>
#include <pkcs12_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_PKCS12_PFX(unsigned char *p, size_t len, const PKCS12_PFX *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* macData */
if((data)->macData) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_PKCS12_MacData(p, len, (data)->macData, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* authSafe */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_ContentInfo(p, len, &(data)->authSafe, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* version */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, &(data)->version, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_PKCS12_PFX(const unsigned char *p, size_t len, PKCS12_PFX *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t version_datalen, version_oldlen;
Der_type version_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &version_type, UT_Integer, &version_datalen, &l);
if (e == 0 && version_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
version_oldlen = len;
if (version_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = version_datalen;
e = der_get_heim_integer(p, len, &(data)->version, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = version_oldlen - version_datalen;
}
e = decode_ContentInfo(p, len, &(data)->authSafe, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
(data)->macData = calloc(1, sizeof(*(data)->macData));
if ((data)->macData == NULL) goto fail;
e = decode_PKCS12_MacData(p, len, (data)->macData, &l);
if(e) {
free((data)->macData);
(data)->macData = NULL;
} else {
p += l; len -= l; ret += l;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_PKCS12_PFX(data);
return e;
}

void ASN1CALL
free_PKCS12_PFX(PKCS12_PFX *data)
{
der_free_heim_integer(&(data)->version);
free_ContentInfo(&(data)->authSafe);
if((data)->macData) {
free_PKCS12_MacData((data)->macData);
free((data)->macData);
(data)->macData = NULL;
}
}

size_t ASN1CALL
length_PKCS12_PFX(const PKCS12_PFX *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer(&(data)->version);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_ContentInfo(&(data)->authSafe);
ret += Top_tag_oldret;
}
if((data)->macData){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_PKCS12_MacData((data)->macData);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_PKCS12_PFX(const PKCS12_PFX *from, PKCS12_PFX *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_heim_integer(&(from)->version, &(to)->version)) goto fail;
if(copy_ContentInfo(&(from)->authSafe, &(to)->authSafe)) goto fail;
if((from)->macData) {
(to)->macData = malloc(sizeof(*(to)->macData));
if((to)->macData == NULL) goto fail;
if(copy_PKCS12_MacData((from)->macData, (to)->macData)) goto fail;
}else
(to)->macData = NULL;
return 0;
fail:
free_PKCS12_PFX(to);
return ENOMEM;
}



