/* Generated from ./cms.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <cms_asn1.h>
#include <cms_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_SignedData(unsigned char *p, size_t len, const SignedData *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* signerInfos */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_SignerInfos(p, len, &(data)->signerInfos, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* crls */
if((data)->crls) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_heim_any(p, len, (data)->crls, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* certificates */
if((data)->certificates) {
size_t Top_tag_oldret = ret;
ret = 0;
{
struct heim_octet_string *val;
size_t elen = 0, totallen = 0;
int eret = 0;
if (((data)->certificates)->len > UINT_MAX/sizeof(val[0]))
return ERANGE;
val = malloc(sizeof(val[0]) * ((data)->certificates)->len);
if (val == NULL && ((data)->certificates)->len != 0) return ENOMEM;
for(i = 0; i < ((data)->certificates)->len; i++) {
ASN1_MALLOC_ENCODE(heim_any, val[i].data, val[i].length, &((data)->certificates)->val[i], &elen, eret);
if(eret) {
i--;
while (i >= 0) {
free(val[i].data);
i--;
}
free(val);
return eret;
}
totallen += elen;
}
if (totallen > len) {
for (i = 0; i < ((data)->certificates)->len; i++) {
free(val[i].data);
}
free(val);
return ASN1_OVERFLOW;
}
qsort(val, ((data)->certificates)->len, sizeof(val[0]), _heim_der_set_sort);
for(i = ((data)->certificates)->len - 1; i >= 0; --i) {
p -= val[i].length;
ret += val[i].length;
memcpy(p + 1, val[i].data, val[i].length);
free(val[i].data);
}
free(val);
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* encapContentInfo */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_EncapsulatedContentInfo(p, len, &(data)->encapContentInfo, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* digestAlgorithms */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_DigestAlgorithmIdentifiers(p, len, &(data)->digestAlgorithms, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* version */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_CMSVersion(p, len, &(data)->version, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_SignedData(const unsigned char *p, size_t len, SignedData *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if((is_indefinite = _heim_fix_dce(Top_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }e = decode_CMSVersion(p, len, &(data)->version, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_DigestAlgorithmIdentifiers(p, len, &(data)->digestAlgorithms, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_EncapsulatedContentInfo(p, len, &(data)->encapContentInfo, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t certificates_datalen, certificates_oldlen;
Der_type certificates_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &certificates_type, 0, &certificates_datalen, &l);
if (e == 0 && certificates_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->certificates = NULL;
} else {
(data)->certificates = calloc(1, sizeof(*(data)->certificates));
if ((data)->certificates == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
certificates_oldlen = len;
if((is_indefinite = _heim_fix_dce(certificates_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }{
size_t certificates_Tag_origlen = len;
size_t certificates_Tag_oldret = ret;
size_t certificates_Tag_olen = 0;
void *certificates_Tag_tmp;
ret = 0;
((data)->certificates)->len = 0;
((data)->certificates)->val = NULL;
while(ret < certificates_Tag_origlen) {
size_t certificates_Tag_nlen = certificates_Tag_olen + sizeof(*(((data)->certificates)->val));
if (certificates_Tag_olen > certificates_Tag_nlen) { e = ASN1_OVERFLOW; goto fail; }
certificates_Tag_olen = certificates_Tag_nlen;
certificates_Tag_tmp = realloc(((data)->certificates)->val, certificates_Tag_olen);
if (certificates_Tag_tmp == NULL) { e = ENOMEM; goto fail; }
((data)->certificates)->val = certificates_Tag_tmp;
e = decode_heim_any(p, len, &((data)->certificates)->val[((data)->certificates)->len], &l);
if(e) goto fail;
p += l; len -= l; ret += l;
((data)->certificates)->len++;
len = certificates_Tag_origlen - ret;
}
ret += certificates_Tag_oldret;
}
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &certificates_type, UT_EndOfContent, &certificates_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (certificates_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = certificates_oldlen - certificates_datalen;
}
}
{
size_t crls_datalen, crls_oldlen;
Der_type crls_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &crls_type, 1, &crls_datalen, &l);
if (e == 0 && crls_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->crls = NULL;
} else {
(data)->crls = calloc(1, sizeof(*(data)->crls));
if ((data)->crls == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
crls_oldlen = len;
if((is_indefinite = _heim_fix_dce(crls_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }e = decode_heim_any(p, len, (data)->crls, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &crls_type, UT_EndOfContent, &crls_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (crls_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = crls_oldlen - crls_datalen;
}
}
e = decode_SignerInfos(p, len, &(data)->signerInfos, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &Top_type, UT_EndOfContent, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (Top_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_SignedData(data);
return e;
}

void ASN1CALL
free_SignedData(SignedData *data)
{
free_CMSVersion(&(data)->version);
free_DigestAlgorithmIdentifiers(&(data)->digestAlgorithms);
free_EncapsulatedContentInfo(&(data)->encapContentInfo);
if((data)->certificates) {
while(((data)->certificates)->len){
free_heim_any(&((data)->certificates)->val[((data)->certificates)->len-1]);
((data)->certificates)->len--;
}
free(((data)->certificates)->val);
((data)->certificates)->val = NULL;
free((data)->certificates);
(data)->certificates = NULL;
}
if((data)->crls) {
free_heim_any((data)->crls);
free((data)->crls);
(data)->crls = NULL;
}
free_SignerInfos(&(data)->signerInfos);
}

size_t ASN1CALL
length_SignedData(const SignedData *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_CMSVersion(&(data)->version);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_DigestAlgorithmIdentifiers(&(data)->digestAlgorithms);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_EncapsulatedContentInfo(&(data)->encapContentInfo);
ret += Top_tag_oldret;
}
if((data)->certificates){
size_t Top_tag_oldret = ret;
ret = 0;
{
size_t certificates_tag_oldret = ret;
int i;
ret = 0;
for(i = ((data)->certificates)->len - 1; i >= 0; --i){
size_t certificates_tag_for_oldret = ret;
ret = 0;
ret += length_heim_any(&((data)->certificates)->val[i]);
ret += certificates_tag_for_oldret;
}
ret += certificates_tag_oldret;
}
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->crls){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_heim_any((data)->crls);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_SignerInfos(&(data)->signerInfos);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_SignedData(const SignedData *from, SignedData *to)
{
memset(to, 0, sizeof(*to));
if(copy_CMSVersion(&(from)->version, &(to)->version)) goto fail;
if(copy_DigestAlgorithmIdentifiers(&(from)->digestAlgorithms, &(to)->digestAlgorithms)) goto fail;
if(copy_EncapsulatedContentInfo(&(from)->encapContentInfo, &(to)->encapContentInfo)) goto fail;
if((from)->certificates) {
(to)->certificates = malloc(sizeof(*(to)->certificates));
if((to)->certificates == NULL) goto fail;
if((((to)->certificates)->val = malloc(((from)->certificates)->len * sizeof(*((to)->certificates)->val))) == NULL && ((from)->certificates)->len != 0)
goto fail;
for(((to)->certificates)->len = 0; ((to)->certificates)->len < ((from)->certificates)->len; ((to)->certificates)->len++){
if(copy_heim_any(&((from)->certificates)->val[((to)->certificates)->len], &((to)->certificates)->val[((to)->certificates)->len])) goto fail;
}
}else
(to)->certificates = NULL;
if((from)->crls) {
(to)->crls = malloc(sizeof(*(to)->crls));
if((to)->crls == NULL) goto fail;
if(copy_heim_any((from)->crls, (to)->crls)) goto fail;
}else
(to)->crls = NULL;
if(copy_SignerInfos(&(from)->signerInfos, &(to)->signerInfos)) goto fail;
return 0;
fail:
free_SignedData(to);
return ENOMEM;
}



