/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <rfc2459_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_TBSCRLCertList(unsigned char *p, size_t len, const TBSCRLCertList *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* crlExtensions */
if((data)->crlExtensions) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Extensions(p, len, (data)->crlExtensions, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* revokedCertificates */
if((data)->revokedCertificates) {
size_t Top_tag_oldret = ret;
ret = 0;
for(i = ((data)->revokedCertificates)->len - 1; i >= 0; --i) {
size_t revokedCertificates_tag_for_oldret = ret;
ret = 0;
/* crlEntryExtensions */
if((&((data)->revokedCertificates)->val[i])->crlEntryExtensions) {
size_t revokedCertificates_tag_S_Of_tag_oldret = ret;
ret = 0;
e = encode_Extensions(p, len, (&((data)->revokedCertificates)->val[i])->crlEntryExtensions, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += revokedCertificates_tag_S_Of_tag_oldret;
}
/* revocationDate */
{
size_t revokedCertificates_tag_S_Of_tag_oldret = ret;
ret = 0;
e = encode_Time(p, len, &(&((data)->revokedCertificates)->val[i])->revocationDate, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += revokedCertificates_tag_S_Of_tag_oldret;
}
/* userCertificate */
{
size_t revokedCertificates_tag_S_Of_tag_oldret = ret;
ret = 0;
e = encode_CertificateSerialNumber(p, len, &(&((data)->revokedCertificates)->val[i])->userCertificate, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += revokedCertificates_tag_S_Of_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += revokedCertificates_tag_for_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* nextUpdate */
if((data)->nextUpdate) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Time(p, len, (data)->nextUpdate, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* thisUpdate */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Time(p, len, &(data)->thisUpdate, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* issuer */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Name(p, len, &(data)->issuer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* signature */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_AlgorithmIdentifier(p, len, &(data)->signature, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* version */
if((data)->version) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Version(p, len, (data)->version, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int ASN1CALL
decode_TBSCRLCertList(const unsigned char *p, size_t len, TBSCRLCertList *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;
const unsigned char *begin = p;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
(data)->version = calloc(1, sizeof(*(data)->version));
if ((data)->version == NULL) goto fail;
e = decode_Version(p, len, (data)->version, &l);
if(e) {
free((data)->version);
(data)->version = NULL;
} else {
p += l; len -= l; ret += l;
}
e = decode_AlgorithmIdentifier(p, len, &(data)->signature, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_Name(p, len, &(data)->issuer, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_Time(p, len, &(data)->thisUpdate, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
(data)->nextUpdate = calloc(1, sizeof(*(data)->nextUpdate));
if ((data)->nextUpdate == NULL) goto fail;
e = decode_Time(p, len, (data)->nextUpdate, &l);
if(e) {
free((data)->nextUpdate);
(data)->nextUpdate = NULL;
} else {
p += l; len -= l; ret += l;
}
{
size_t revokedCertificates_datalen, revokedCertificates_oldlen;
Der_type revokedCertificates_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &revokedCertificates_type, UT_Sequence, &revokedCertificates_datalen, &l);
if (e == 0 && revokedCertificates_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->revokedCertificates = NULL;
} else {
(data)->revokedCertificates = calloc(1, sizeof(*(data)->revokedCertificates));
if ((data)->revokedCertificates == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
revokedCertificates_oldlen = len;
if (revokedCertificates_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = revokedCertificates_datalen;
{
size_t revokedCertificates_Tag_origlen = len;
size_t revokedCertificates_Tag_oldret = ret;
size_t revokedCertificates_Tag_olen = 0;
void *revokedCertificates_Tag_tmp;
ret = 0;
((data)->revokedCertificates)->len = 0;
((data)->revokedCertificates)->val = NULL;
while(ret < revokedCertificates_Tag_origlen) {
size_t revokedCertificates_Tag_nlen = revokedCertificates_Tag_olen + sizeof(*(((data)->revokedCertificates)->val));
if (revokedCertificates_Tag_olen > revokedCertificates_Tag_nlen) { e = ASN1_OVERFLOW; goto fail; }
revokedCertificates_Tag_olen = revokedCertificates_Tag_nlen;
revokedCertificates_Tag_tmp = realloc(((data)->revokedCertificates)->val, revokedCertificates_Tag_olen);
if (revokedCertificates_Tag_tmp == NULL) { e = ENOMEM; goto fail; }
((data)->revokedCertificates)->val = revokedCertificates_Tag_tmp;
{
size_t revokedCertificates_Tag_s_of_datalen, revokedCertificates_Tag_s_of_oldlen;
Der_type revokedCertificates_Tag_s_of_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &revokedCertificates_Tag_s_of_type, UT_Sequence, &revokedCertificates_Tag_s_of_datalen, &l);
if (e == 0 && revokedCertificates_Tag_s_of_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
revokedCertificates_Tag_s_of_oldlen = len;
if (revokedCertificates_Tag_s_of_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = revokedCertificates_Tag_s_of_datalen;
e = decode_CertificateSerialNumber(p, len, &(&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len])->userCertificate, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_Time(p, len, &(&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len])->revocationDate, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
(&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len])->crlEntryExtensions = calloc(1, sizeof(*(&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len])->crlEntryExtensions));
if ((&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len])->crlEntryExtensions == NULL) goto fail;
e = decode_Extensions(p, len, (&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len])->crlEntryExtensions, &l);
if(e) {
free((&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len])->crlEntryExtensions);
(&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len])->crlEntryExtensions = NULL;
} else {
p += l; len -= l; ret += l;
}
len = revokedCertificates_Tag_s_of_oldlen - revokedCertificates_Tag_s_of_datalen;
}
((data)->revokedCertificates)->len++;
len = revokedCertificates_Tag_origlen - ret;
}
ret += revokedCertificates_Tag_oldret;
}
len = revokedCertificates_oldlen - revokedCertificates_datalen;
}
}
{
size_t crlExtensions_datalen, crlExtensions_oldlen;
Der_type crlExtensions_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &crlExtensions_type, 0, &crlExtensions_datalen, &l);
if (e == 0 && crlExtensions_type != CONS) { e = ASN1_BAD_ID; }
if(e) {
(data)->crlExtensions = NULL;
} else {
(data)->crlExtensions = calloc(1, sizeof(*(data)->crlExtensions));
if ((data)->crlExtensions == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
crlExtensions_oldlen = len;
if (crlExtensions_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = crlExtensions_datalen;
e = decode_Extensions(p, len, (data)->crlExtensions, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = crlExtensions_oldlen - crlExtensions_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
data->_save.data = calloc(1, ret);
if (data->_save.data == NULL) { 
e = ENOMEM; goto fail; 
}
data->_save.length = ret;
memcpy(data->_save.data, begin, ret);
if(size) *size = ret;
return 0;
fail:
free_TBSCRLCertList(data);
return e;
}

void ASN1CALL
free_TBSCRLCertList(TBSCRLCertList *data)
{
der_free_octet_string(&data->_save);
if((data)->version) {
free_Version((data)->version);
free((data)->version);
(data)->version = NULL;
}
free_AlgorithmIdentifier(&(data)->signature);
free_Name(&(data)->issuer);
free_Time(&(data)->thisUpdate);
if((data)->nextUpdate) {
free_Time((data)->nextUpdate);
free((data)->nextUpdate);
(data)->nextUpdate = NULL;
}
if((data)->revokedCertificates) {
while(((data)->revokedCertificates)->len){
free_CertificateSerialNumber(&(&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len-1])->userCertificate);
free_Time(&(&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len-1])->revocationDate);
if((&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len-1])->crlEntryExtensions) {
free_Extensions((&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len-1])->crlEntryExtensions);
free((&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len-1])->crlEntryExtensions);
(&((data)->revokedCertificates)->val[((data)->revokedCertificates)->len-1])->crlEntryExtensions = NULL;
}
((data)->revokedCertificates)->len--;
}
free(((data)->revokedCertificates)->val);
((data)->revokedCertificates)->val = NULL;
free((data)->revokedCertificates);
(data)->revokedCertificates = NULL;
}
if((data)->crlExtensions) {
free_Extensions((data)->crlExtensions);
free((data)->crlExtensions);
(data)->crlExtensions = NULL;
}
}

size_t ASN1CALL
length_TBSCRLCertList(const TBSCRLCertList *data)
{
size_t ret = 0;
if((data)->version){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Version((data)->version);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_AlgorithmIdentifier(&(data)->signature);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Name(&(data)->issuer);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Time(&(data)->thisUpdate);
ret += Top_tag_oldret;
}
if((data)->nextUpdate){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Time((data)->nextUpdate);
ret += Top_tag_oldret;
}
if((data)->revokedCertificates){
size_t Top_tag_oldret = ret;
ret = 0;
{
size_t revokedCertificates_tag_oldret = ret;
int i;
ret = 0;
for(i = ((data)->revokedCertificates)->len - 1; i >= 0; --i){
size_t revokedCertificates_tag_for_oldret = ret;
ret = 0;
{
size_t revokedCertificates_tag_S_Of_tag_oldret = ret;
ret = 0;
ret += length_CertificateSerialNumber(&(&((data)->revokedCertificates)->val[i])->userCertificate);
ret += revokedCertificates_tag_S_Of_tag_oldret;
}
{
size_t revokedCertificates_tag_S_Of_tag_oldret = ret;
ret = 0;
ret += length_Time(&(&((data)->revokedCertificates)->val[i])->revocationDate);
ret += revokedCertificates_tag_S_Of_tag_oldret;
}
if((&((data)->revokedCertificates)->val[i])->crlEntryExtensions){
size_t revokedCertificates_tag_S_Of_tag_oldret = ret;
ret = 0;
ret += length_Extensions((&((data)->revokedCertificates)->val[i])->crlEntryExtensions);
ret += revokedCertificates_tag_S_Of_tag_oldret;
}
ret += 1 + der_length_len (ret);
ret += revokedCertificates_tag_for_oldret;
}
ret += revokedCertificates_tag_oldret;
}
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->crlExtensions){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Extensions((data)->crlExtensions);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int ASN1CALL
copy_TBSCRLCertList(const TBSCRLCertList *from, TBSCRLCertList *to)
{
memset(to, 0, sizeof(*to));
{ int ret;
ret = der_copy_octet_string(&(from)->_save, &(to)->_save);
if (ret) goto fail;
}
if((from)->version) {
(to)->version = malloc(sizeof(*(to)->version));
if((to)->version == NULL) goto fail;
if(copy_Version((from)->version, (to)->version)) goto fail;
}else
(to)->version = NULL;
if(copy_AlgorithmIdentifier(&(from)->signature, &(to)->signature)) goto fail;
if(copy_Name(&(from)->issuer, &(to)->issuer)) goto fail;
if(copy_Time(&(from)->thisUpdate, &(to)->thisUpdate)) goto fail;
if((from)->nextUpdate) {
(to)->nextUpdate = malloc(sizeof(*(to)->nextUpdate));
if((to)->nextUpdate == NULL) goto fail;
if(copy_Time((from)->nextUpdate, (to)->nextUpdate)) goto fail;
}else
(to)->nextUpdate = NULL;
if((from)->revokedCertificates) {
(to)->revokedCertificates = malloc(sizeof(*(to)->revokedCertificates));
if((to)->revokedCertificates == NULL) goto fail;
if((((to)->revokedCertificates)->val = malloc(((from)->revokedCertificates)->len * sizeof(*((to)->revokedCertificates)->val))) == NULL && ((from)->revokedCertificates)->len != 0)
goto fail;
for(((to)->revokedCertificates)->len = 0; ((to)->revokedCertificates)->len < ((from)->revokedCertificates)->len; ((to)->revokedCertificates)->len++){
if(copy_CertificateSerialNumber(&(&((from)->revokedCertificates)->val[((to)->revokedCertificates)->len])->userCertificate, &(&((to)->revokedCertificates)->val[((to)->revokedCertificates)->len])->userCertificate)) goto fail;
if(copy_Time(&(&((from)->revokedCertificates)->val[((to)->revokedCertificates)->len])->revocationDate, &(&((to)->revokedCertificates)->val[((to)->revokedCertificates)->len])->revocationDate)) goto fail;
if((&((from)->revokedCertificates)->val[((to)->revokedCertificates)->len])->crlEntryExtensions) {
(&((to)->revokedCertificates)->val[((to)->revokedCertificates)->len])->crlEntryExtensions = malloc(sizeof(*(&((to)->revokedCertificates)->val[((to)->revokedCertificates)->len])->crlEntryExtensions));
if((&((to)->revokedCertificates)->val[((to)->revokedCertificates)->len])->crlEntryExtensions == NULL) goto fail;
if(copy_Extensions((&((from)->revokedCertificates)->val[((to)->revokedCertificates)->len])->crlEntryExtensions, (&((to)->revokedCertificates)->val[((to)->revokedCertificates)->len])->crlEntryExtensions)) goto fail;
}else
(&((to)->revokedCertificates)->val[((to)->revokedCertificates)->len])->crlEntryExtensions = NULL;
}
}else
(to)->revokedCertificates = NULL;
if((from)->crlExtensions) {
(to)->crlExtensions = malloc(sizeof(*(to)->crlExtensions));
if((to)->crlExtensions == NULL) goto fail;
if(copy_Extensions((from)->crlExtensions, (to)->crlExtensions)) goto fail;
}else
(to)->crlExtensions = NULL;
return 0;
fail:
free_TBSCRLCertList(to);
return ENOMEM;
}



