/* Generated from ./pkinit.asn1 */
/* Do not edit */

#define  ASN1_LIB

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <pkinit_asn1.h>
#include <pkinit_asn1-priv.h>
#include <asn1_err.h>
#include <der.h>
#include <der-private.h>
#include <asn1-template.h>
#include <parse_units.h>

int ASN1CALL
encode_TrustedCA_Win2k(unsigned char *p, size_t len, const TrustedCA_Win2k *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;

switch((data)->element) {
case choice_TrustedCA_Win2k_issuerAndSerial: {size_t Top_oldret = ret;
ret = 0;
e = encode_IssuerAndSerialNumber(p, len, &((data))->u.issuerAndSerial, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 2, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
case choice_TrustedCA_Win2k_caName: {size_t Top_oldret = ret;
ret = 0;
e = encode_heim_any(p, len, &((data))->u.caName, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
};
*size = ret;
return 0;
}

int ASN1CALL
decode_TrustedCA_Win2k(const unsigned char *p, size_t len, TrustedCA_Win2k *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
if (der_match_tag(p, len, ASN1_C_CONTEXT, CONS, 1, NULL) == 0) {
{
size_t caName_datalen, caName_oldlen;
Der_type caName_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &caName_type, 1, &caName_datalen, &l);
if (e == 0 && caName_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
caName_oldlen = len;
if (caName_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = caName_datalen;
e = decode_heim_any(p, len, &(data)->u.caName, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = caName_oldlen - caName_datalen;
}
(data)->element = choice_TrustedCA_Win2k_caName;
}
else if (der_match_tag(p, len, ASN1_C_CONTEXT, CONS, 2, NULL) == 0) {
{
size_t issuerAndSerial_datalen, issuerAndSerial_oldlen;
Der_type issuerAndSerial_type;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &issuerAndSerial_type, 2, &issuerAndSerial_datalen, &l);
if (e == 0 && issuerAndSerial_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
issuerAndSerial_oldlen = len;
if (issuerAndSerial_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = issuerAndSerial_datalen;
e = decode_IssuerAndSerialNumber(p, len, &(data)->u.issuerAndSerial, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = issuerAndSerial_oldlen - issuerAndSerial_datalen;
}
(data)->element = choice_TrustedCA_Win2k_issuerAndSerial;
}
else {
e = ASN1_PARSE_ERROR;
goto fail;
}
if(size) *size = ret;
return 0;
fail:
free_TrustedCA_Win2k(data);
return e;
}

void ASN1CALL
free_TrustedCA_Win2k(TrustedCA_Win2k *data)
{
switch((data)->element) {
case choice_TrustedCA_Win2k_caName:
free_heim_any(&(data)->u.caName);
break;
case choice_TrustedCA_Win2k_issuerAndSerial:
free_IssuerAndSerialNumber(&(data)->u.issuerAndSerial);
break;
}
}

size_t ASN1CALL
length_TrustedCA_Win2k(const TrustedCA_Win2k *data)
{
size_t ret = 0;
switch((data)->element) {
case choice_TrustedCA_Win2k_caName:
{
size_t Top_oldret = ret;
ret = 0;
ret += length_heim_any(&(data)->u.caName);
ret += 1 + der_length_len (ret);
ret += Top_oldret;
}
break;
case choice_TrustedCA_Win2k_issuerAndSerial:
{
size_t Top_oldret = ret;
ret = 0;
ret += length_IssuerAndSerialNumber(&(data)->u.issuerAndSerial);
ret += 1 + der_length_len (ret);
ret += Top_oldret;
}
break;
}
return ret;
}

int ASN1CALL
copy_TrustedCA_Win2k(const TrustedCA_Win2k *from, TrustedCA_Win2k *to)
{
memset(to, 0, sizeof(*to));
(to)->element = (from)->element;
switch((from)->element) {
case choice_TrustedCA_Win2k_caName:
if(copy_heim_any(&(from)->u.caName, &(to)->u.caName)) goto fail;
break;
case choice_TrustedCA_Win2k_issuerAndSerial:
if(copy_IssuerAndSerialNumber(&(from)->u.issuerAndSerial, &(to)->u.issuerAndSerial)) goto fail;
break;
}
return 0;
fail:
free_TrustedCA_Win2k(to);
return ENOMEM;
}



